#pragma once

#include <vector>
#include "Message.h"



namespace scai {
	class ILayer;

	class Communication {
		std::vector<ILayer *> layers;
		std::map<ILayer *, std::vector<Message> > messages;

	public:
		void addLayer(ILayer* layer) {
			layers.push_back(layer);
		}

		void sendUp(ILayer* const sender, Message message) {
			std::vector<ILayer*>::const_iterator reciever = std::find(layers.begin(), layers.end(), sender) - 1;
			messages[*reciever].push_back(message);
		}

		void sendDn(ILayer* const sender, Message message) {
			std::vector<ILayer*>::const_iterator reciever = std::find(layers.begin(), layers.end(), sender) + 1;
			messages[*reciever].push_back(message);
		}

		Message getNext(ILayer* const reciever) {
			std::vector<Message>& foo = messages[reciever];
			Message r = foo.front();
			foo.erase(std::find(foo.begin(), foo.end(), r));
			return r;
		}

		bool hasNext(ILayer* const reciever) {
			return !(messages[reciever].empty());
		}
	};
}