#pragma once

#include "log.h"
#include "ILayer.h"
#include "PlanItem.h"
#include "PlanGenerator.h"
#include "Global.h"
#include <BWAPI.h>
#include "TestRunner.h"

namespace scai {
	class Planner : public ILayer {
		bool sent, recieved;
		scai::Communication& comm;
		scai::PlanGenerator planGen;
		std::vector<Plan> plans;

		Plan getPlan() {
			return plans[0];
		}

		void plannerLoop() {

			//Run messageloop to handle any news.
			messageLoop();


			//If we have finished our plan, get a new one
			//TODO: fix for more than one plan :)
			if (plans.size() == 0) {
				log("creating new plan");
				BWAPI::Broodwar->printf("Started plannerloop, no items in plan");

				plans.push_back(planGen.generatePlan());
				Message msg;
				msg.id = NewPlan;
				msg.put("plan", getPlan());
				comm.sendDn(this, msg);
				log("created new plan");
			}	
		}

		void messageLoop() {
			//TODO: process all kinds of messages
			while (comm.hasNext(this)) {
				log("planner has new message");
				Message msg = comm.getNext(this);
				std::string planMessage = "Illegal";
				try {
					planMessage = boost::any_cast<std::string>(msg.get("planFinished"));
				} catch(boost::bad_any_cast e){
					BWAPI::Broodwar->printf("Exception in planning layer when collecting message");
				}
				//TODO: Fix so the given plan ID is removed
				//Some plan was finished, and since we only have one we can terminate that one
				if(planMessage != "Illegal"){
					plans.clear();
				}
				log("planner handled a message");
			}
		}

	public:
		virtual void onFrame() {
			plannerLoop();
		}

		Planner(Communication& comm, const std::string& dbindex, TestRunner* runner)
			: comm(comm)
			, sent(false)
			, planGen(dbindex, runner) 
		{
			
		}
	};
}