#pragma once
#include <stdio.h>

#include <fstream>
#include "log.h"
#include "Case.h"
#include "LocationType.h"

namespace scai {
	class DatabaseReader {
#error foo
	public:

		CaseLibrary readDatabase() {

			const int BUFFER_SIZE = 1024;
			char buffer[BUFFER_SIZE];

			CaseLibrary lib;

			FILE* infile;
			//TODO: Use the actual database, this is testing purposes only
			fopen_s(&infile, "bwapi-data\\logs\\databaseTest.txt", "r");

			if(infile != NULL) {
				fgets(buffer, 1024, infile);
				int cases = getInt(strtok(buffer, " \n"));

				//For each case, do:
				for(int i = 0 ; i < cases ; i++) {
					Case temp;

					//get utility to library
					fgets(buffer, 1024, infile);
					temp.utility = getInt(strtok(buffer, " \n"));

					//get amount of frames 
					fgets(buffer, 1024, infile);
					temp.frames = getInt(strtok(buffer, " \n"));

					//get the map name 
					fgets(buffer, 1024, infile);
					temp.state.map = getStringWithSpace(buffer);

					//get ours and enemy race
					fgets(buffer, 1024, infile);
					temp.state.my_race_id = getInt(strtok(buffer, " \n"));
					temp.state.their_race_id = getInt(strtok(NULL, " \n"));

					//get minerals gas and rates
					fgets(buffer, 1024, infile);
					temp.state.mMinerals = getInt(strtok(buffer, " \n"));
					temp.state.mGas = getInt(strtok(NULL, " \n"));
					temp.state.mMineralsRate = getFloat(strtok(NULL, " \n"));
					temp.state.mGasRate = getFloat(strtok(NULL, " \n"));

					//get amount of harvesters, ours and enemy
					fgets(buffer, 1024, infile);
					temp.state.mHarvesters = getInt(strtok(buffer, " \n"));
					temp.state.eHarvesters = getInt(strtok(NULL, " \n"));

					//get the research we have
					fgets(buffer, 1024, infile);
					int amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						int upgrade_id = getInt(strtok(buffer, " \n"));
						int level = getInt(strtok(NULL, " \n"));
						temp.state.mResearch[upgrade_id] = level;
					}

					//get the research the opponent has
					fgets(buffer, 1024, infile);
					amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						std::string name = getStringWithSpace(buffer);
						fgets(buffer, 1024, infile);
						int level = getInt(strtok(buffer, " \n"));
						temp.state.eResearch[BWAPI::UpgradeTypes::getUpgradeType(name)] = level;
					}

					//Get the units we have
					fgets(buffer, 1024, infile);
					amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						std::string name = getStringWithSpace(buffer);
						fgets(buffer, 1024, infile);
						int count = getInt(strtok(buffer, " \n"));
						scai::Gamestate::Units unit;
						unit.mine = true;
						unit.count = count;
						unit.t = BWAPI::UnitTypes::getUnitType(name);
						temp.state.mUnits.push_back(unit);
					}

					//Get the units the enemy has
					fgets(buffer, 1024, infile);
					amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						std::string name = getStringWithSpace(buffer);
						fgets(buffer, 1024, infile);
						int count = getInt(strtok(buffer, " \n"));
						scai::Gamestate::Units unit;
						unit.mine = false;
						unit.count = count;
						unit.t = BWAPI::UnitTypes::getUnitType(name);
						temp.state.eUnits.push_back(unit);
					}

					//Get the buildings we have
					fgets(buffer, 1024, infile);
					amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						std::string name = getStringWithSpace(buffer);
						fgets(buffer, 1024, infile);
						int count = getInt(strtok(buffer, " \n"));
						scai::Gamestate::Units unit;
						unit.mine = true;
						unit.count = count;
						unit.t = BWAPI::UnitTypes::getUnitType(name);
						temp.state.mBuildings.push_back(unit);
					}

					//Get the buildings the enemy have
					fgets(buffer, 1024, infile);
					amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						std::string name = getStringWithSpace(buffer);
						fgets(buffer, 1024, infile);
						int count = getInt(strtok(buffer, " \n"));
						scai::Gamestate::Units unit;
						unit.mine = false;
						unit.count = count;
						unit.t = BWAPI::UnitTypes::getUnitType(name);
						temp.state.eBuildings.push_back(unit);
					}

					//Get the bases we have
					fgets(buffer, 1024, infile);
					amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						int type = getInt(strtok(buffer, " \n"));
						scai::Gamestate::Bases base;
						base.mine = true;
						base.type = scai::PlanItem::getType(type);
						temp.state.mBases.push_back(base);
					}

					//Get the bases the enemy has
					fgets(buffer, 1024, infile);
					amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						int type = getInt(strtok(buffer, " \n"));
						scai::Gamestate::Bases base;
						base.mine = false;
						base.type = scai::PlanItem::getType(type);
						temp.state.eBases.push_back(base);
					}


					//Get the actions we are to perform
					fgets(buffer, 1024, infile);
					amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						std::string type = getString(strtok(buffer, " \n"));
						if(type == "BUILD"){
							PlanItem item;
							item.myType = scai::Build;
							fgets(buffer, 1024, infile);
							std::string name = getStringWithSpace(buffer);
							item.build.building = BWAPI::UnitTypes::getUnitType(name);
							temp.plan.push_back(item);
						} else if(type == "TRAIN") {
							PlanItem item;
							item.myType = scai::Train;
							fgets(buffer, 1024, infile);
							std::string name = getStringWithSpace(buffer);
							fgets(buffer, 1024, infile);
							int count = getInt(strtok(buffer, " \n"));
							item.train.unit = BWAPI::UnitTypes::getUnitType(name);
							item.train.count = count;
							temp.plan.push_back(item);
						} else if(type == "UPGRADE"){
							PlanItem item;
							item.myType = scai::Upgrade;
							fgets(buffer, 1024, infile);
							std::string name = getStringWithSpace(buffer);
							item.upgrade.upgrade = BWAPI::UpgradeTypes::getUpgradeType(name);
							temp.plan.push_back(item);
						} else if(type == "ATTACK"){
							PlanItem item;
							item.myType = scai::Attack;
							fgets(buffer, 1024, infile);
							int type = getInt(strtok(buffer, " \n"));
							item.attack.location = (scai::LocationType) type;
							temp.plan.push_back(item);
						} else if(type == "DEFEND"){
							PlanItem item;
							item.myType = scai::Defend;
							fgets(buffer, 1024, infile);
							int type = getInt(strtok(buffer, " \n"));
							item.defend.location = scai::PlanItem::getType(type);;
							temp.plan.push_back(item);
						} else if(type == "EXPAND"){
							PlanItem item;
							item.myType = scai::Expand;
							fgets(buffer, 1024, infile);
							int type = getInt(strtok(buffer, " \n"));
							item.defend.location = scai::PlanItem::getType(type);;
							temp.plan.push_back(item);
						} else if(type == "SCOUT"){
							PlanItem item;
							item.myType = scai::Scout;
							fgets(buffer, 1024, infile);
							int type = getInt(strtok(buffer, " \n"));
							item.defend.location = scai::PlanItem::getType(type);;
							temp.plan.push_back(item);
						} else {
							// TODO: Write some error stuff.
						}
					}

					//Get the actions the enemy plans to perform
					fgets(buffer, 1024, infile);
					amount = getInt(strtok(buffer, " \n"));

					for(int i = 0 ; i < amount ; i++) {
						fgets(buffer, 1024, infile);
						std::string type = getString(strtok(buffer, " \n"));
						if(type == "BUILD"){
							PlanItem item;
							item.myType = scai::Build;
							fgets(buffer, 1024, infile);
							std::string name = getStringWithSpace(buffer);
							item.build.building = BWAPI::UnitTypes::getUnitType(name);
							temp.opponentmodel.push_back(item);
						} else if(type == "TRAIN") {
							PlanItem item;
							item.myType = scai::Train;
							fgets(buffer, 1024, infile);
							std::string name = getStringWithSpace(buffer);
							fgets(buffer, 1024, infile);
							int count = getInt(strtok(buffer, " \n"));
							item.train.unit = BWAPI::UnitTypes::getUnitType(name);
							item.train.count = count;
							temp.opponentmodel.push_back(item);
						} else if(type == "UPGRADE"){
							PlanItem item;
							item.myType = scai::Upgrade;
							fgets(buffer, 1024, infile);
							std::string name = getStringWithSpace(buffer);
							item.upgrade.upgrade = BWAPI::UpgradeTypes::getUpgradeType(name);
							temp.opponentmodel.push_back(item);
						} else if(type == "ATTACK"){
							PlanItem item;
							item.myType = scai::Attack;
							fgets(buffer, 1024, infile);
							int type = getInt(strtok(buffer, " \n"));
							item.attack.location = scai::PlanItem::getType(type);;
							temp.opponentmodel.push_back(item);
						} else if(type == "DEFEND"){
							PlanItem item;
							item.myType = scai::Defend;
							fgets(buffer, 1024, infile);
							int type = getInt(strtok(buffer, " \n"));
							item.defend.location = scai::PlanItem::getType(type);;
							temp.opponentmodel.push_back(item);
						} else if(type == "EXPAND"){
							PlanItem item;
							item.myType = scai::Expand;
							fgets(buffer, 1024, infile);
							int type = getInt(strtok(buffer, " \n"));
							item.defend.location = scai::PlanItem::getType(type);;
							temp.opponentmodel.push_back(item);
						} else if(type == "SCOUT"){
							PlanItem item;
							item.myType = scai::Scout;
							fgets(buffer, 1024, infile);
							int type = getInt(strtok(buffer, " \n"));
							item.defend.location = scai::PlanItem::getType(type);;
							temp.opponentmodel.push_back(item);
						} else {
							//  TODO: Error stuff..
						}
					}
					lib.push_back(temp);
				}

				fclose(infile);
			}
			else {
				//  TODO: Error stuff..
			}

			return lib;
		}
	private:
		int getInt(char* item) {
			int i;
			if(EOF == sscanf(item, "%d", &i)) {
			  return 0;
			}

			return i;
		}

		float getFloat(char* item) {
			float i;
			if(EOF == sscanf(item, "%f", &i)) {
			  return 0;
			}

			return i;
		}

		std::string getString(char* item) {
			std::string temp = item;
			return temp;

		}
		std::string getStringWithSpace(char buffer[]) {
			std::string value = "";
			char* temp;
			temp = strtok(buffer, " \n");
			if(temp == NULL) {
				return "";
			} else {
				value.append(temp);
			}
			temp = strtok(NULL, " \n");
			while(temp != NULL) {
				value.append(" ");
				value.append(temp);
				temp = strtok(NULL, " \n");
			}
			return value;
		}
	};
}