#pragma once
#include <BWAPI.h>
#include <BWTA.h>
#include <Arbitrator.h>
#include <BuildManager.h>
/*
#include <WorkerManager.h>
#include <SupplyManager.h>
#include <BuildOrderManager.h>
#include <TechManager.h>
#include <UpgradeManager.h>
#include <BaseManager.h>
#include <ScoutManager.h>
#include <DefenseManager.h>
#include <InformationManager.h>
#include <BorderManager.h>
//#include <UnitGroupManager.h>
#include <EnhancedUI.h>
*/

#include "ILayer.h"
#include "Planner.h"
#include "Executive.h"
#include "Reactive.h"
#include "Global.h"

#include <boost/lambda/lambda.hpp>

#include "Communication.h"
#include "PlanItem.h"

class BasicAIModule : public BWAPI::AIModule
{
public:

	scai::ILayer *planner, *executive, *reactive;
	scai::Communication comm;

	virtual void onStart();
	virtual void onEnd(bool isWinner);
	virtual void onFrame();
	virtual void onUnitDiscover(BWAPI::Unit* unit);
	virtual void onUnitEvade(BWAPI::Unit* unit);
	virtual void onUnitMorph(BWAPI::Unit* unit);
	virtual void onUnitRenegade(BWAPI::Unit* unit);
	virtual void onUnitCreate(BWAPI::Unit* unit);
	virtual void onUnitDestroy(BWAPI::Unit* unit);
	virtual void onSendText(std::string text);
	
	~BasicAIModule(); //not part of BWAPI::AIModule
	
	void showStats(); //not part of BWAPI::AIModule
	void showPlayers();
	void showForces();
	
	bool analyzed;
	bool showManagerAssignments;
	std::map<BWAPI::Unit*,BWAPI::UnitType> buildings;
	
	
	Arbitrator::Arbitrator<BWAPI::Unit*,double> arbitrator;
	BuildManager* buildManager;
};