#pragma once

#include <vector>
#include <BWAPI.h>

namespace scai {
	enum PlanItemType {Build, Train, Upgrade, Attack, Defend, Expand, Scout};
	
	
	struct PlanItem {
		PlanItem(): behaviourId(-1) {}
		PlanItemType myType;
		const char* name() {
			switch (myType) {
			case scai::Build: return "Build";
			case scai::Train: return "Train";
			case scai::Upgrade: return "Upgrade";
			case scai::Attack: return "Attack";
			case scai::Defend: return "Defend";
			case scai::Expand: return "Expand";
			case scai::Scout: return "Scout";
			default: return "JAN IS A FAILBOT!";
			}
		}
		

		struct Build {
			// For build
			BWAPI::UnitType building;
		};

		struct Train {
			// For train
			BWAPI::UnitType unit;
			int count;
		};

		struct Upgrade {
			// For upgrade
			BWAPI::UpgradeType upgrade;
		};

		struct Attack {
			// For attack
			BWAPI::Position position;
		};

		struct Defend {
			BWAPI::Position position;
		};

		struct Expand {
			BWAPI::Position position;
		};

		struct Scout {
			BWAPI::Position position;
		};

		Build build;
		Train train;
		Upgrade upgrade;
		Attack attack;
		Defend defend;
		Expand expand;
		Scout scout;

		//Use this field to see if this planitem has assigned a behaviour to it. If value is -1, no behaviour
		int behaviourId;
	};

	typedef std::vector<PlanItem> Plan;
}