#pragma once
#include <BWAPI.h>
#include <BWTA.h>
#include "Tracer.h"
#include <vector>
#include <string>

class BasicAIModule : public BWAPI::AIModule
{
	scai::Tracer tracer;
	std::vector<std::string> traces;
	bool do_write;

	bool analyzed; 
public:
	virtual void onStart();
	virtual void onEnd(bool isWinner);
	virtual void onFrame();
	virtual void onUnitDiscover(BWAPI::Unit* unit);
	virtual void onUnitEvade(BWAPI::Unit* unit);
	virtual void onUnitMorph(BWAPI::Unit* unit);
	virtual void onUnitRenegade(BWAPI::Unit* unit);
	virtual void onUnitCreate(BWAPI::Unit* unit);
	virtual void onUnitDestroy(BWAPI::Unit* unit);
	virtual void onSendText(std::string text);
	
	void load_traces();
	void save_traces();
	void stop_replays() const;

	~BasicAIModule();
};