#include <vector>
#include <iostream>
#include <fstream>
#include <string>

#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/vector.hpp>

#include <Trace.h>
#include "Analyzer.h"
#include "Case.h"
#include "Database.h"

const char* usage = "analyze database [trace-file]+";
const char* test = "F:\\Master\\StarCraft\\traces\\538924_ShuttlePvsUEDHob.rep.trace";

int main(int argc, const char* argv[])
{
#if 0
	std::cerr << "Starting" << std::endl;
	std::string n(test);
	std::cerr << "Loading" << std::endl;
	scai::Trace t;
	std::ifstream f(n.c_str());
	if (!f) throw 42;
	boost::archive::text_iarchive ar(f);
	try {
		ar >> t;
		Analyzer a(t);
		std::cerr << "Loaded" << std::endl;
		a.analyze(0);
	} catch (std::exception e) {
		std::cerr << "Error: " << e.what() << '\n';
	}
#else
	std::cout <<"Starting" << std::endl;
	if (argc < 3) {
		std::cout <<"only one argument" << std::endl;
		std::cerr << usage << std::endl;
		return -1;
	}
	std::cout << "Post if check" << std::endl;

	for (int i = 0; i != argc; ++i)
		std::cout << i << " = " << argv[i] << std::endl;

	scai::Database db;
	std::cout <<"Starting db writing"<< std::endl;
	for (int i = 2; i != argc; ++i) {
		std::cout <<"Trying to load trace file"<< std::endl;
		std::string trace_file(argv[i]);
		Analyzer analyzer(trace_file);
		std::cout <<"Loaded trace file at "<<i<< argv[i]<< std::endl;
		std::vector<size_t> players = analyzer.valid_players();
		for (size_t j = 0; j != players.size(); ++j) {
			//If we have PVP matches we want each match to have an unique matchid
			if(j > 0) {
				std::stringstream thing;
				thing << argv[i] << "_" << i;
				std::string f;
				f = thing.str();
				std::cout<<"analysing for player at position "<<j<<std::endl;
				scai::CaseLibrary cases = analyzer.analyze(players[j], f);
				db.append(cases);
			}
			else {
				std::cout<<"analysing for player at position "<<j<<std::endl;
				scai::CaseLibrary cases = analyzer.analyze(players[j], argv[i]);
				db.append(cases);
			}
		}
		std::cout <<"Appended cases"<< std::endl;
	}
	std::cout <<"Writing database" << std::endl;
	db.write_database(argv[1]);
	std::cout <<"Wrote database"<< std::endl;

#endif
}